#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "gun2zero4xi.py">
#<abstract4xi abstract = "guns to zero"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'gun2zero4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from dummyprocess4xi import DummyProcess4Xi

from shoot2zero4xi import shoot2zero4xi

from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "

      
#"
#"/>
    
             
# -----------------------------------------------------------------------------------------------------
#<function4xi function = "gun2zero4xi" usage = "
#   gun for MainProcess4Xi
#"> 
# -----------------------------------------------------------------------------------------------------
       
def gun2zero4xi(queue2work, channel2consume, channel2publish):
    '''
    guns for Process4Xi-8
    '''    
        
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    print('=' *33)
    print("(STEP 1/33) OF GUN2ZERO4XI, START TIME: ", time4xi()) 
    print('=' *33)
    #
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     

    queue2work4zero = queue2work
    
    print('~' *33)
    print("(STEP 2/33) OF GUN2ZERO4XI, QUEUE2WORK4ZERO: ", queue2work4zero)
    print('~' *33)
    # <queue4xi.Queue4Xi object at 0x02DA28F0> 
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    channel2consume4zero = channel2consume
    print('~' *33)
    print("(STEP 3/33) OF GUN2ZERO4XI, CHANNEL2CONSUME4ZERO: ", channel2consume4zero)
    print('~' *33)
    # <read-write PipeConnection, handle 296> 
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    channel2publish4zero = channel2publish
    print('~' *33)
    print("(STEP 4/33) OF GUN2ZERO4XI, CHANNEL2PUBLISH4ZERO: ", channel2publish4zero)
    print('~' *33)
    # <read-write PipeConnection, handle 300> 
        
    
    # ---------------------------------------------------------------------------------------------    
    # GETTING FROM QUEUE
    # --------------------------------------------------------------------------------------------- 
        
    try:
        message2qet4zero = queue2work4zero.get()
        print("(STEP 5A/33) OF GUN2ZERO4XI - MESSAGE2QET4ZERO GOT: ", message2qet4zero) 
        # <copy4xi>copy2zero</copy4xi>
        
        if message2qet4zero == "<copy4xi>copy2zero</copy4xi>":
            message2put4zero = "<roger4xi>roger2zero</roger4xi>"
            print("(STEP 5B/33) OF GUN2ZERO4XI - SET MESSAGE2PUT4ZERO TO: ", message2put4zero) 
            # <roger4xi>roger2zero</roger4xi>
        else:
            print("(STEP 5c/33) OF GUN2ZERO4XI - *** UNREGONIZED MESSAGE GOT: ", message2qet4zero)           
            message2put4zero = "<negative4xi>negative2zero</negative4xi>"
            print("(STEP 5d/33) OF GUN2ZERO4XI - SET MESSAGE2PUT4ZERO TO: ", message2put4zero)             
    except:
        message2put4zero = "<negative4xi>negative2zero</negative4xi>"
    
    
    # ---------------------------------------------------------------------------------------------    
    # PUTTING TO QUEUE
    # --------------------------------------------------------------------------------------------- 
    print("(STEP 6A/33) OF GUN2ZERO4XI - TRYING TO PUT MESSAGE2PUT4ZERO: ", message2put4zero)                                  
    try:         
        queue2work4zero.put(message2put4zero) 
        print('~' *33)
        print("(STEP 6B/33) OF GUN2ZERO4XI - PUT TO QUEUE2WORK4ZERO: ", queue2work4zero, ' MESSAGE2PUT4ZERO: ', message2put4zero)
        print('~' *33)
        # PUT TO QUEUE2WORK4ZERO:  <queue4xi.Queue4Xi object at 0x02DA28F0>  MESSAGE2PUT4ZERO:  <roger4xi>roger2zero</roger4xi> 
        
    except:
        print("(STEP 6c/33) OF GUN2ZERO4XI *** FAILED TO PUT TO QUEUE2WORK4ZERO: ", queue2work4zero, ' MESSAGE2PUT4ZERO: ', message2put4zero)
                   
    # ---------------------------------------------------------------------------------------------    
    # RECEIVING FROM PIPE CONSUMER CHANNEL
    # ---------------------------------------------------------------------------------------------     

    print("(STEP 7A/33) OF GUN2ZERO4XI - TRYING TO RECEIVE FROM CHANNEL2CONSUME4ZERO: ", channel2consume4zero)
    try:
        message2receive4zero = channel2consume4zero.recv()
        print("(STEP 7B/33) OF GUN2ZERO4XI - RECEIVED MESSAGE2RECEIVE4ZERO: ", message2receive4zero)
        # <copy4xi>copy2zero</copy4xi>
        
        if message2receive4zero == "<copy4xi>copy2zero</copy4xi>":
            message2send4zero = "<roger4xi>roger2zero</roger4xi>"
            print("(STEP 7C/33) OF GUN2ZERO4XI - SET MESSAGE2SEND4ZERO: ", message2send4zero)
            # <roger4xi>roger2zero</roger4xi>
        else:
            message2send4zero = "<negative4xi>negative2zero</negative4xi>"
            print("(STEP 7D/33) OF GUN2ZERO4XI - SET MESSAGE2SEND4ZERO: ", message2send4zero)        
    except:
        print("(STEP 7E/33) OF GUN2ZERO4XI - *** EXCEPTION WITH CHANNEL2CONSUME4ZERO.RECV: ", channel2consume4zero.recv) 
        message2send4zero = "<negative4xi>negative2zero</negative4xi>"
        print("(STEP 7F/33) OF GUN2ZERO4XI - SET MESSAGE2SEND4ZERO: ", message2send4zero)       
            
        
            
    # ---------------------------------------------------------------------------------------------
    # SEND DATA TO THE PIPE'S PUBLISHER CHANNEL 
    # ---------------------------------------------------------------------------------------------
    print("(STEP 8A/33) OF GUN2ZERO4XI - TRYING TO SEND DATA TO CHANNEL2PUBLISHER4ZERO: ", channel2publish4zero)
    # 
    try:         
        channel2publish4zero.send(message2send4zero)
        print("(STEP 8B/33) OF GUN2ZERO4XI - SENT MESSAGE2SEND4ZERO: ", message2send4zero, " CHANNEL2PUBLISHER4ZERO: ", channel2publish4zero)
        # SENT MESSAGE2SEND4ZERO:  <roger4xi>roger2zero</roger4xi>  CHANNEL2PUBLISHER4ZERO:  <read-write PipeConnection, handle 300> 
    except:
        print("(STEP 8C/33) OF GUN2ZERO4XI - *** FAILED TO SEND MESSAGE2SEND4ZERO: ", message2send4zero, " CHANNEL2PUBLISHER4ZERO: ", channel2publish4zero) 
    
    # ---------------------------------------------------------------------------------------------    
    # PERFORMING MANOEUVRE 
    # --------------------------------------------------------------------------------------------- 
    print("(STEP 9A/33) OF GUN2ZERO4XI - TRYING MANOEUVRE SPHERE2WNB: (-X,-Y,-Z) - WEST, NORTH, BACKWARDS")     
    ack2function = False
    if ack2function is True:
        # -----------------------------------------------------------------------------------------    
        # Using the function to shoot - this approach works, but blocks return to MainProcess4Xi! 
        # -----------------------------------------------------------------------------------------        
        try: 
            sphere2wnb = shoot2zero4xi(start2distance = 100, interval2distance = 100, max2layer = 100, max2count = 200, marginal2count = 1.2, sign2x = '-', sign2y = '-', sign2z = '-',
                                        max2iterate = 4200, increase2distance = None, change2a = pi/60 , change2e = pi/60, increase2a = 0.01, increase2e = 0.01,
                                        start2plusa = 3.1991885189056037, max2plusa = 2*pi, min2plusa = pi/240, start2minusa = -pi/6 , max2minusa = -0.98*2*pi, min2minusa = -pi/240,
                                        start2pluse = 2.1335987755982972, max2pluse = pi, min2pluse = pi/240, start2minuse = -pi/6, max2minuse = -0.98*pi, min2minuse = -pi/240)                    
                               
            print("(STEP 9B/33) OF GUN2ZERO4XI - PERFORMED MANOEUVRE SPHERE2WNB: (-X,-Y,-Z) - WEST, NORTH, BACKWARDS")       
            # for results search (STEP 32/33) OF SHOOT2ZERO4XI - STATISTICS FOR REQUIRED           
        except:
            print("(STEP 9C/33) OF GUN2ZERO4XI *** FAILED TO PERFORM MANOEUVRE SPHERE2WNB: (-X,-Y,-Z) - WEST, NORTH, BACKWARDS")        
    else:
        pass
        
    ack2process = True
    if ((ack2process is True) and (ack2function is False)):
        # -----------------------------------------------------------------------------------------    
        # Using the dummy process to shoot - this approach tries faster return to MainProcess4Xi  
        # -----------------------------------------------------------------------------------------      
        print("(STEP 10A/33) OF GUN2ZERO4XI - CREATING A DUMMY PROCESS4XI")  
        ack2dummy = False
        
        # -----------------------------------------------------------------------------------------    
        # create the dummy process object 
        # -----------------------------------------------------------------------------------------          
        try:                            # latest ok shot
            start2distance = 10         # 2,     3,   4,  10, 3300
            interval2distance = 10      # 2,    10,  10,  10, 100, 
            max2layer = 10              # 10,   10,  10,  10, 100, 
            marginal2layer = 1.2        # 1.2, 1.2, 1.2, 1.2, 1.2
            max2count = 80              # 100,  10,  10,  10, 100

            # to be checked in test_sphere4xi.txt: 
            # [1] (STEP 27M5/33) OF SHOOT2ZERO4XI - NEW LAYER NUMBER:
            
            # example 2:   9  NEW DISTANCE:  90  <-- ok i.e. does not overlap with 100
            
            # example 1:  10  NEW DISTANCE:  100 <-- should not overlap with other shots!           
            # 
            # [2] (STEP 32/33) OF SHOOT2ZERO4XI - STATISTICS FOR REQUIRED
            
            # example 2: 
            #  SUM2TOTAL:  324 SUCCESS-RATIO:  98  %  COUNT2LAYER:  9
            #  START2DISTANCE:  10  INTERVAL2DISTANCE:  10  MAX2LAYER:  12  MAX2COUNT :  96
            #  EXPECTED COORDINATE SIGNS: (X - ,Y - ,Z - )
            #  REASONING: 
            #  OK SHOOTING: ACCEPTED SHOTS  95  >=  80  ORIGINALLY REQUIRED, MARIGINAL:  1.2            
            
            # example 1:
            # SUM2TOTAL:  542 SUCCESS-RATIO:  100  %  COUNT2LAYER:  11
            # START2DISTANCE:  10  INTERVAL2DISTANCE:  10  MAX2LAYER:  12  MAX2COUNT :  120 <-- too many layers overlapping with other shots
            # OK SHOOTING: ACCEPTED SHOTS  121  >=  100  ORIGINALLY REQUIRED, MARIGINAL:  1.2 <-- marginal generated too many layers
            
            #10: -10x-10y-12z, -5x-5y-6z, -6x-4y-6z, -7x-2y-5z, -7x-3y-5z, -8x-1y-5z, 8x0y-5z   
            # 4: -1x-2y-2z,    -2x-1y-2z, -2x-2y-2z, -3x-1y-2z, -3x0y-2z,  -6x-8y-9z 
            # 3: -1x-1y-2z,    -2x-1y-1z, -2x0y-1z,  -4x-8y-8z
            # 2: -1x-11y-2z ...6x-8y-6z, 0x-10y-8z ... 0x0y-9z
            

            
            marginal2count = 1.2
            sign2x = '-'
            sign2y = '-'
            sign2z = '-'
            max2iterate = 2400
            
            start2plusa = 3.1991885189056037
            max2plusa = 2*pi
            min2plusa = pi/240
            start2minusa = -pi/6
            max2minusa = -0.98*2*pi
            min2minusa = -pi/240
            
            start2pluse = 2.1335987755982972
            max2pluse = pi
            min2pluse = pi/240
            start2minuse = -pi/6
            max2minuse = -0.98*pi
            min2minuse = -pi/240
            
            increase2distance = 1
            change2a = pi/60
            change2e = pi/60
            increase2a = 0.01
            increase2e = 0.01        
                    
            dummy2zero = DummyProcess4Xi(target=shoot2zero4xi, 
                                               args =(queue2work4zero,
                                                      channel2consume4zero, channel2publish4zero,
                                                      start2distance, interval2distance, max2layer, marginal2layer,max2count,
                                                      marginal2count, sign2x, sign2y, sign2z, max2iterate, 
                                                      start2plusa, max2plusa, min2plusa, start2minusa, max2minusa, min2minusa,
                                                      start2pluse, max2pluse, min2pluse, start2minuse, max2minuse, min2minuse,
                                                      increase2distance, change2a, change2e, increase2a, increase2e))

          
            print("(STEP 10B/33) OF GUN2ZERO4XI - CREATED DUMMY_PROCESS4XI OBJECT DUMMY2ZERO: ", dummy2zero) 
            # <DummyProcess4Xi(Thread-8, initial)> 
            
            ack2dummy = True
        except:
            print("(STEP 10C/33) OF GUN2ZERO4XI *** FAILED TO CREATE DUMMY_PROCESS4XI OBJECT DUMMY2ZERO ***")
            ack2dummy = False
            
        # -----------------------------------------------------------------------------------------    
        # start the dummy process object
        # -----------------------------------------------------------------------------------------              
        if ack2dummy is True:
            print("(STEP 10D/33) OF GUN2ZERO4XI - STARTING THE DUMMY PROCESS4XI TIME: ", time4xi())  
            ack2start = False
            try:      
                dummy2zero.start() 
                print("(STEP 10E/33) OF GUN2ZERO4XI - STARTED THE DUMMY PROCESS4XI DUMMY2ZERO: ", dummy2zero)

                ack2start = True
            except:
                print("(STEP 10F/33) OF GUN2ZERO4XI *** FAILED TO START THE DUMMY PROCESS4XI ***")
        else:
            print("(STEP 10G/33) OF GUN2ZERO4XI ** YIELDED STARTING THE DUMMY PROCESS4XI - ACK2DUMMY: ", ack2dummy)
            ack2start = False 
    else:
        print("(STEP 10H/33) OF GUN2ZERO4XI ** YIELDED STARTING THE DUMMY PROCESS4XI - ACK2DUMMY: ", ack2dummy, " ACK2FUNCTION: ", ack2function)
                                
                                                                           
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     

    print('=' *33)
    print("(STEP 11/33) OF GUN2ZERO4XI - RETURNING TIME: ", time4xi())
    print('=' *33)
    # 
    
#</function4xi>

#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_sphere4xi.txt
#   sense-test-sphere4xi.xml
#   reason-test-sphere4xi.xml
#   ace-test-sphere4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of gun24xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
